; Rough Disassembly of Stone Age
; By Omegamatrix
; Last update Dec 31, 2013
;
;
; The CCE rom looks pirated from TechnoVision. They did a horrible job,
; leaving the colors as PAL and chopping too many scanlines out. This is
; a much better conversion. This dissasembly is at an early stage...
;
;
; stone.cfg contents:
;
;      ORG F000
;      CODE F000 F2D5
;      GFX F2D6 F2D9
;      CODE F2DA F36F
;      GFX F370 F513
;      CODE F514 FB07
;      GFX FB08 FB0F
;      CODE FB10 FBE9
;      GFX FBEA FBF6
;      CODE FBF7 FCE3
;      GFX FCE4 FD1F
;      CODE FD20 FE55
;      GFX FE56 FFFF

      processor 6502
      include vcs.h
      include stoneAge.h
COL_NTSC = 1                 ; 0 = PAL colors
      include colors.h




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;      RIOT RAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

       SEG.U RIOT_RAM
       ORG $80

gameMode           ds 1  ; $80  Why they didn't just use playerNum?
frameCounter       ds 1  ; $81
ram_82             ds 1  ; x3
ram_83             ds 1  ; x5
cavemanYpos        ds 1  ; $84
ram_85             ds 1  ; x2
cavemanPtr         ds 2  ; $86-$87
tempPtr            ds 2  ; $88-$89
dinosaurPtr        equ tempPtr

ram_8A             ds 1  ; x2
ram_8B             ds 1  ; x1
ram_8C             ds 1  ; x2
ram_8D             ds 1  ; x1
ram_8E             ds 1  ; x2
ram_8F             ds 1  ; x1
ram_90             ds 1  ; x2
ram_91             ds 1  ; x1

stoneOrder         ds 16 ; $92-A1

ram_A2             ds 1  ; x3
ram_A3             ds 1  ; x3
ram_A4             ds 1  ; x3
ram_A5             ds 1  ; x3
ram_A6             ds 1  ; x3
ram_A7             ds 1  ; x3
ram_A8             ds 1  ; x8
ram_A9             ds 1  ; x4
cavemanColPtr      ds 2  ; $AA-$AB
ram_AC             ds 1  ; x5
ram_AD             ds 1  ; x26
ram_AE             ds 1  ; x20
cavemanXpos        ds 1  ; $AF
reflectCaveman     ds 1  ; $B0
ram_B1             ds 1  ; x2
ram_B2             ds 1  ; x31
ram_B3             ds 1  ; x26
ram_B4             ds 1  ; x14
reflectDinoGfx     ds 4  ; $B5-$B8
dinoLoPtr          ds 4  ; $B9-$BC
dinoColors         ds 4  ; $BD-$C0   color is cleared to 0 when dinosaur is dead, used as a marker to skip drawing it
currentDinosaur    ds 1  ; $C1       selects which dinosaur to draw, 1-4
dinoPositions      ds 4  ; $C2-$C5
indexDinosaurs     ds 1  ; $C6
slidingBlock       ds 1  ; $C7  ; caveman push block direction?
ram_C8             ds 1  ; x7
ram_C9             ds 2  ; x7
ram_CB             ds 2  ; x6
levelNum           ds 2  ; $CD P0, $CE P1  ; no more then 16 levels. Level is stored minus 1, running 0-15.
playerNum          ds 1  ; 0 = P0, 1 = P1
ram_D0             ds 1  ; x6
ram_D1             ds 1  ; x6
numOfLivesP0       ds 1  ; $D2
numOfLivesP1       ds 1  ; $D3
ram_D4             ds 1  ; x5
ram_D5             ds 1  ; x3
difficultyP0       ds 1  ; $D6
difficultyP1       ds 1  ; $D7
ram_D8             ds 4  ; $D8-$DB
ram_DC             ds 1  ; x3
ram_DD             ds 1  ; x4
ram_DE             ds 1  ; x7
ram_DF             ds 1  ; x4
ram_E0             ds 1  ; x2
ram_E1             ds 1  ; x2
ram_E2             ds 1  ; x2
ram_E3             ds 1  ; x2
ram_E4             ds 1  ; x2
ram_E5             ds 1  ; x2
ram_E6             ds 26 ; x5

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;      USER CONSTANTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TIME_VBLANK            = 40-1
OVERSCAN_DELAY         = 17  ; scanlines

;colors
COL_P0                 = COL_42
COL_P1                 = COL_94

COL_P0_LIVES_DISPLAY   = COL_P0
COL_P1_LIVES_DISPLAY   = COL_P1
COL_SCORE_BK_P0        = COL_P0
COL_SCORE_BK_P1        = COL_P1
COL_SCORE              = COL_2A
COL_LOGO_BAR           = COL_DA
COL_PF_BLOCKS          = COL_2A
COL_PF_BLOCKS_BLUE     = COL_B8  ; time almost done!

COL_DINO1              = COL_36
COL_DINO2              = COL_56
COL_DINO3              = COL_BA
COL_DINO4              = COL_16



RESET_SWITCH           = $01
SELECT_SWITCH          = $02
EASY_SETTING           = $0F  ; AND value for framecounter
HARD_SETTING           = $07  ; dinosaurs move twice as fast
DIFFICULTY_SWITCH_P1   = $40

START_LIVES            = $03  ; lives display is not set up to handle any more...
GAME_MODE_FLAG         = 1    ; gets EOR'd with player number, maybe to change players?

DEAD_DINOSAUR_FLAG     = 0
DINO_NUM_MASK          = $03
BLOCK_SLIDING_FLAG     = $80
BLOCK_NOT_SLIDING      = $00

TOP_YPOS_CAVEMAN       = 1  ; top of screen
BOTTOM_YPOS_CAVEMAN    = 8  ; bottom of screen

NO_REFLECT             = $00
REFLECT_GFX            = $08

DIR_80                 = $80
DIR_40                 = $40
DIR_20                 = $20
DIR_10                 = $10

DIR_08                 = %0111 ; %0100 DIR_40
DIR_02                 = %1101 ; %0001 DIR_10

DIR_04                 = %1011 ; %1000 DIR_80
DIR_01                 = %1110 ; %0010 DIR_20


TONE_SLIDING_BLOCK     = $03
FREQ_SLIDING_BLOCK     = $07
VOL_SLIDING_BLOCK      = $0D


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      MAIN PROGRAM
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

       SEG CODE
       ORG $F000

START:
    ldx    #$FF                  ; 2
    txs                          ; 2
    cld                          ; 2
    ldx    #$00                  ; 2
    lda    #$00                  ; 2
LF008:
    sta    0,X                   ; 4
    dex                          ; 2
    bne    LF008                 ; 2


    jsr    LFBF7                 ; 6
    lda    #$04                  ; 2
    sta    AUDC0                 ; 3
    lda    #$12                  ; 2
    sta    AUDF0                 ; 3
    lda    #$F4                  ; 2
    sta    ram_8B                ; 3
    sta    ram_8D                ; 3
    sta    ram_8F                ; 3
    sta    ram_91                ; 3
    lda    #$FF                  ; 2
    sta    ram_D1                ; 3
    sta    ram_DE                ; 3
LF028:
    jsr    LF2DA                 ; 6
    jsr    CheckSwitches
    jsr    LFC5C                 ; 6
    jsr    LFB5E                 ; 6
    jsr    LF5A1                 ; 6
    jsr    LF5BE                 ; 6
    jsr    LF724                 ; 6
    jsr    DinosaurMovement
    jsr    LF7DA                 ; 6
    jsr    LF920                 ; 6
    jsr    LFA93                 ; 6
LF049:
    jsr    LFB26                 ; 6
    jsr    LF052                 ; 6
    jmp    LF028                 ; 3

LF052:
    lda    #$00                  ; 2
    sta    ram_83                ; 3
    lda    #$03                  ; 2
    sta    NUSIZ0                ; 3
    lda    #$01                  ; 2
    sta    NUSIZ1                ; 3


LF05E:
    lda    INTIM                 ; 4
    bne    LF05E                 ; 2
    
    LDA    #$10  
    sta    WSYNC                 ; 3
;---------------------------------------
 ;   sta    VBLANK                ; 3
    STA    HMP1
    ldx    #7
LF06B:
    dex                          ; 2
    bne    LF06B                 ; 2
    sta    RESP0                 ; 3
    sta    RESP1                 ; 3
;     lda    #$10                  ; 2
;     sta    HMP1                  ; 3
    sta    WSYNC                 ; 3
;---------------------------------------
    sta    HMOVE                 ; 3
    STA    WSYNC
    STA    VBLANK
    
    
    lda    #COL_SCORE_BK_P0
    ldy    playerNum             ; 3
    beq    LF082                 ; 2
    lda    #COL_SCORE_BK_P1
LF082:
    sta    COLUBK
    lda    #COL_SCORE
    sta    COLUP0
    sta    COLUP1
    ldy    #0
LF092:
    sta    WSYNC                 ; 3
;---------------------------------------
    lda    (ram_8A),Y            ; 5
    sta    GRP0                  ; 3
    lda    (ram_8C),Y            ; 5
    sta    GRP1                  ; 3
    lda    (ram_8E),Y            ; 5
    tax                          ; 2
    lda    (ram_90),Y            ; 5
    sta    ram_AD                ; 3
    sty    ram_AE                ; 3
    lda    LF494,Y               ; 4
    ldy    ram_AD                ; 3
    nop                          ; 2
    nop                          ; 2
    stx    GRP0                  ; 3
    sty    GRP1                  ; 3
    sta    GRP0                  ; 3
    ldy    ram_AE                ; 3
    iny                          ; 2
    cpy    #$08                  ; 2
    bne    LF092                 ; 2
    sta    WSYNC                 ; 3
;---------------------------------------
    lda    #$00                  ; 2
    sta    GRP0                  ; 3
    sta    GRP1                  ; 3
    sta    COLUBK                ; 3   black
    lda    #$05                  ; 2
    sta    NUSIZ0                ; 3
    sta    NUSIZ1                ; 3
    ldx    #$FE                  ; 2
    stx    ram_A9                ; 3
    lda    reflectCaveman        ; 3
    sta    REFP0                 ; 3
    ldx    cavemanXpos
    dex                          ; 2
    lda    LF48A,X               ; 4
    JMP   .skipNop

    NOP
    NOP   $EA
    NOP   $EA
    NOP   $EA
    NOP   $EA
    NOP   $EA
    NOP   $EA
    NOP   $EA
  ;  NOP   $EA

.skipNop
    sta    WSYNC                 ; 3
;---------------------------------------
    tax                          ; 2
    sta    HMCLR                 ; 3
    sta    HMP0                  ; 3
    and    #$0F                  ; 2
    tax                          ; 2
LF0E5:
    dex                          ; 2
    bne    LF0E5                 ; 2
    sta    RESP0                 ; 3
    sta    WSYNC                 ; 3
;---------------------------------------
    sta    HMOVE                 ; 3
    ldx    currentDinosaur
    lda    reflectDinoGfx,X
    sta    REFP1
    lda    dinoLoPtr,X
    sta    dinosaurPtr
    ldx    ram_B1                ; 3
    dex                          ; 2
    lda    LF48A,X               ; 4
    sta    WSYNC                 ; 3
;---------------------------------------
    tax                          ; 2
    sta    HMCLR                 ; 3
    sta    HMP1                  ; 3
    and    #$0F                  ; 2
    tax                          ; 2
LF110:
    dex                          ; 2
    bne    LF110                 ; 2
    sta    RESP1                 ; 3
    sta    WSYNC                 ; 3
;---------------------------------------
    sta    HMOVE                 ; 3
    ldy    ram_DC                ; 3
    sty    COLUPF                ; 3
    ldx    currentDinosaur
    lda    dinoColors,X
    sta    COLUP1                ; 3
    ldx    #$00                  ; 2

    DEC    $2E
    DEC    $2E
    STA    HMCLR


LF12B:
    sta    WSYNC                 ; 3
;---------------------------------------
    lda    #$00                  ; 2
    sta    PF0                   ; 3
    sta    PF1                   ; 3
    stx    GRP0                  ; 3
    sta    PF2                   ; 3
    sta    ram_A8                ; 3
    inc    ram_A9                ; 5
    inc    ram_A9                ; 5
    ldx    ram_A9                ; 3
    lda    stoneOrder,X
    and    #$03                  ; 2
    tay                          ; 2
    lda    LF458,Y               ; 4
    sta    ram_A4                ; 3
    lda    LF469,Y               ; 4
    sta    ram_E2                ; 3
    lda    stoneOrder,X
    and    #$0C                  ; 2
    tay                          ; 2

    sta    WSYNC                 ; 3
;---------------------------------------
    lda    #$00                  ; 2
    sta    GRP1                  ; 3
    lda    LF458,Y               ; 4
    sta    ram_A3                ; 3
    lda    LF469,Y               ; 4
    sta    ram_E1                ; 3
    lda    stoneOrder,X
    and    #$10                  ; 2
    tay                          ; 2
    lda    LF458,Y               ; 4
    sta    ram_A2                ; 3
    lda    LF469,Y               ; 4
    sta    ram_E0                ; 3
    lda    stoneOrder+1,X
    and    #$03                  ; 2
    tay                          ; 2
    lda    LF458,Y               ; 4
    sta    ram_A7                ; 3
    lda    LF469,Y               ; 4
    sta    ram_E5                ; 3
    lda    stoneOrder+1,X
    and    #$0C                  ; 2
    tay                          ; 2
    lda    LF458,Y               ; 4
    sta    WSYNC                 ; 3
;---------------------------------------
    sta    ram_A6                ; 3
    lda    LF469,Y               ; 4
    sta    ram_E4                ; 3
    lda    stoneOrder+1,X
    and    #$10                  ; 2
    tay                          ; 2
    lda    LF458,Y               ; 4
    sta    ram_A5                ; 3
    lda    LF469,Y               ; 4
    sta    ram_E3                ; 3
    ldx    #$00                  ; 2
    inc    ram_83                ; 5
    lda    ram_83                ; 3
    cmp    #$09                  ; 2
    bne    LF1AE                 ; 2
    jmp    LF234                 ; 3

LF1AE:
    sta    WSYNC                 ; 3
;---------------------------------------
    lda    ram_A2                ; 3
    sta    PF0                   ; 3
    lda    ram_A3                ; 3
    sta    PF1                   ; 3
    lda    ram_A4                ; 3
    sta    PF2                   ; 3
    stx    GRP1                  ; 3
    ldy    ram_A8                ; 3
    lda    ram_A5                ; 3
    sta    PF0                   ; 3
    lda    (cavemanPtr),Y        ; 5
    tax                          ; 2
    lda    ram_A6                ; 3
    sta    PF1                   ; 3
    lda    (cavemanColPtr),Y     ; 5
    ldy    ram_A7                ; 3
    sty    PF2                   ; 3
    ldy    ram_83                ; 3
    cpy    cavemanYpos
    beq    LF1D9                 ; 2
    ldx    #$00                  ; 2
LF1D9:
    tay                          ; 2
    lda    ram_E0                ; 3
    sta    WSYNC                 ; 3
;---------------------------------------
    sta    PF0                   ; 3
    lda    ram_E1                ; 3
    sta    PF1                   ; 3
    lda    ram_E2                ; 3
    sta    PF2                   ; 3
    stx    GRP0                  ; 3
    sty    COLUP0                ; 3
    lda    ram_E3                ; 3
    sta    PF0                   ; 3
    ldy    ram_A8                ; 3
    inc    ram_A8                ; 5
    lda    ram_E4                ; 3
    sta    PF1                   ; 3
    lda    (dinosaurPtr),Y
    tax                          ; 2
    lda    ram_E5                ; 3
    sta    PF2                   ; 3
    lda    ram_83                ; 3
    cmp    ram_85                ; 3
    beq    LF207                 ; 2
    ldx    #$00                  ; 2
LF207:
    lda    ram_A8                ; 3
    cmp    #$08                  ; 2
    bne    LF1AE                 ; 2+1
    sta    WSYNC                 ; 3
;---------------------------------------
    lda    ram_A2                ; 3
    sta    PF0                   ; 3
    lda    ram_A3                ; 3
    sta    PF1                   ; 3
    lda    ram_A4                ; 3
    sta    PF2                   ; 3
    stx    GRP1                  ; 3
    ldx    #$00                  ; 2
    lda    ram_A5                ; 3
    sta    PF0                   ; 3
    ldy    ram_A8                ; 3
    lda    ram_A6                ; 3
    sta    PF1                   ; 3
    ldy    ram_A8                ; 3
    ldy    ram_A8                ; 3
    lda    ram_A7                ; 3
    sta    PF2                   ; 3
    jmp    LF12B                 ; 3

LF234:
    sta    WSYNC                 ; 3
;---------------------------------------
    lda    #$00                  ; 2
    sta    COLUP0                ; 3  black
    sta    COLUP1                ; 3
    lda    #$00                  ; 2
    sta    HMP0                  ; 3
    sta    HMP1                  ; 3
    sta    REFP0                 ; 3
    sta    REFP1                 ; 3
    ldx    #$08                  ; 2
    sta    WSYNC                 ; 3
;---------------------------------------
LF24A:
    dex                          ; 2
    bne    LF24A                 ; 2
    sta    RESP0                 ; 3
    sta    RESP1                 ; 3
    lda    #$10                  ; 2
    sta    HMP1                  ; 3
    sta    WSYNC                 ; 3
;---------------------------------------
    sta    HMOVE                 ; 3
;     lda    #$03                  ; 2
;     sta    NUSIZ0                ; 3
;     lda    #$01                  ; 2
;     sta    NUSIZ1                ; 3
;     ldy    #$00                  ; 2
;     lda    #$3A                  ; 2
;     sta    WSYNC                 ; 3
; ;---------------------------------------
;     sta    COLUBK                ; 3
;     lda    ram_AD                ; 3
;     nop                          ; 2
    LDA    #3
    STA    NUSIZ0
    LSR             ; A=1
    STA    NUSIZ1
    TAY             ; Y=1
    LDA    #COL_LOGO_BAR
    STA    WSYNC
;---------------------------------------
    STA    COLUBK
    LDA    ram_AD
    DEY             ; Y=0

LF26C:
    lda    TechnoVisionLogo_A,Y  ; 4
    sta    GRP0                  ; 3
    lda    TechnoVisionLogo_B,Y  ; 4
    sta    GRP1                  ; 3
    lda    TechnoVisionLogo_C,Y  ; 4
    sta    ram_AD                ; 3
    ldx    TechnoVisionLogo_D,Y  ; 4
    lda    TechnoVisionLogo_E,Y  ; 4
    sty    ram_AE                ; 3
    ldy    ram_AD                ; 3
    sty    GRP0                  ; 3
    stx    GRP1                  ; 3
    sta    GRP0                  ; 3
    inc    ram_AE                ; 5
    sta    WSYNC                 ; 3
;---------------------------------------
    ldy    ram_AE                ; 3
    cpy    #$08                  ; 2
    bne    LF26C                 ; 2
    LDY    #$00
    STY    GRP0
    STY    GRP1
    STY    COLUBK      ; black
    STY    HMP0
    STY    HMP1
    STA    WSYNC
;---------------------------------------
    INY
    STY    CTRLPF
    LDY    #$05


LF2A9:
    lda    #COL_P0_LIVES_DISPLAY
    sta    WSYNC                 ; 3
;---------------------------------------
    sta    COLUPF                ; 3
    ldx    numOfLivesP0          ; 3
    lda    LivesDisplayTab,X     ; 4
    sta    PF1                   ; 3
    ldx    numOfLivesP1          ; 3
    lda    LivesDisplayTab,X     ; 4
    ldx    #COL_P1_LIVES_DISPLAY
    DEC    $2E
    DEC    $2E
    NOP
    DEY
    STX    COLUPF
    STA    PF1

    bne    LF2A9                 ; 2
    sta    WSYNC                 ; 3
;---------------------------------------
;     lda    #$00                  ; 2
;     sta    COLUPF                ; 3
;     sta    PF1                   ; 3
;     sta    CTRLPF                ; 3
;     rts                          ; 6
    STY    COLUPF  ; black
    STY    PF1
    STY    CTRLPF
    RTS


LivesDisplayTab:
    .byte $00 ; |        | $F2D6
    .byte $80 ; |X       | $F2D7
    .byte $A0 ; |X X     | $F2D8
    .byte $A8 ; |X X X   | $F2D9

LF2DA:
    inc    frameCounter          ; 5
    lda    frameCounter          ; 3
    and    #$3F                  ; 2
    bne    LF2E4                 ; 2
    inc    ram_82                ; 5
LF2E4:
    lda    #$02                  ; 2
    sta    WSYNC                 ; 3
;---------------------------------------
    sta    VBLANK                ; 3
    lda    frameCounter          ; 3
    bne    LF2F6                 ; 2
    ldx    currentDinosaur
    lda    ram_D8,X              ; 4
    ora    #$0F                  ; 2
    sta    ram_D8,X              ; 4
LF2F6:
    sta    WSYNC                 ; 3
;---------------------------------------
    lda    frameCounter          ; 3
    and    #$07                  ; 2
    bne    LF315                 ; 2+1
    lda    ram_E6                ; 3
    bne    LF315                 ; 2
    ldx    ram_AC                ; 3
    lda    LF370,X               ; 4
    sta    AUDF0                 ; 3
    inc    ram_AC                ; 5
    lda    ram_AC                ; 3
    cmp    #$38                  ; 2
    bne    LF315                 ; 2
    lda    #$00                  ; 2
    sta    ram_AC                ; 3
LF315:

    LDX    #OVERSCAN_DELAY
.loopDelay:
    STA    WSYNC
;---------------------------------------
    DEX
    BNE    .loopDelay

    lda    #$02                  ; 2
    sta    WSYNC                 ; 3
;---------------------------------------
    sta    VSYNC                 ; 3
    lda    playerNum             ; 3
    bne    LF32D                 ; 2
    lda    SWCHA                 ; 4
    LSR
    LSR
    LSR
    LSR
    sta    ram_D4                ; 3
    lda    INPT4
    sta    ram_D5                ; 3
    jmp    LF33A                 ; 3

LF32D:
    lda    SWCHA                 ; 4
    AND    #$0F
    sta    ram_D4                ; 3
    lda    INPT5
    sta    ram_D5                ; 3
LF33A:
    lda    currentDinosaur
    sta    ram_AD                ; 3
    ldy    #3
    sta    WSYNC                 ; 3
;---------------------------------------
.loopFindDinosaur:
    inc    currentDinosaur
    lda    #DINO_NUM_MASK        ; no more then 4 dinosaurs
    and    currentDinosaur
    tax
    lda    dinoColors,X          ; is dino dead?
    bne    LF352                 ; - no, dinosaur found
    dey                          ; - yes, keep looking
    bne    .loopFindDinosaur
    ldx    ram_AD                ; use previous shown dinosaur
LF352:
    sta    WSYNC
;---------------------------------------
    stx    currentDinosaur
    lda    dinoPositions,X
    lsr                          ; 2
    lsr                          ; 2
    lsr                          ; 2
    lsr                          ; 2
    sta    ram_85                ; 3
    lda    #$0F                  ; 2
    and    dinoPositions,X
    sta    ram_B1                ; 3
    lda    #$00                  ; 2
    sta    WSYNC                 ; 3
;---------------------------------------
    sta    VSYNC                 ; 3
    lda    #TIME_VBLANK          ; 2
    sta    TIM64T                ; 4
    rts                          ; 6

LF370:
    .byte $1F ; |   XXXXX| $F370
    .byte $1F ; |   XXXXX| $F371
    .byte $15 ; |   X X X| $F372
    .byte $15 ; |   X X X| $F373
    .byte $1F ; |   XXXXX| $F374
    .byte $1F ; |   XXXXX| $F375
    .byte $15 ; |   X X X| $F376
    .byte $15 ; |   X X X| $F377
    .byte $1C ; |   XXX  | $F378
    .byte $1C ; |   XXX  | $F379
    .byte $15 ; |   X X X| $F37A
    .byte $15 ; |   X X X| $F37B
    .byte $1C ; |   XXX  | $F37C
    .byte $1C ; |   XXX  | $F37D
    .byte $15 ; |   X X X| $F37E
    .byte $15 ; |   X X X| $F37F
    .byte $1F ; |   XXXXX| $F380
    .byte $1F ; |   XXXXX| $F381
    .byte $15 ; |   X X X| $F382
    .byte $15 ; |   X X X| $F383
    .byte $1F ; |   XXXXX| $F384
    .byte $1F ; |   XXXXX| $F385
    .byte $15 ; |   X X X| $F386
    .byte $15 ; |   X X X| $F387
    .byte $1C ; |   XXX  | $F388
    .byte $1C ; |   XXX  | $F389
    .byte $15 ; |   X X X| $F38A
    .byte $15 ; |   X X X| $F38B
    .byte $1C ; |   XXX  | $F38C
    .byte $1C ; |   XXX  | $F38D
    .byte $15 ; |   X X X| $F38E
    .byte $15 ; |   X X X| $F38F
    .byte $1F ; |   XXXXX| $F390
    .byte $1F ; |   XXXXX| $F391
    .byte $15 ; |   X X X| $F392
    .byte $15 ; |   X X X| $F393
    .byte $1C ; |   XXX  | $F394
    .byte $1C ; |   XXX  | $F395
    .byte $15 ; |   X X X| $F396
    .byte $15 ; |   X X X| $F397
    .byte $1F ; |   XXXXX| $F398
    .byte $1F ; |   XXXXX| $F399
    .byte $1C ; |   XXX  | $F39A
    .byte $1C ; |   XXX  | $F39B
    .byte $19 ; |   XX  X| $F39C
    .byte $19 ; |   XX  X| $F39D
    .byte $1C ; |   XXX  | $F39E
    .byte $1C ; |   XXX  | $F39F
    .byte $1F ; |   XXXXX| $F3A0
    .byte $1C ; |   XXX  | $F3A1
    .byte $19 ; |   XX  X| $F3A2
    .byte $1C ; |   XXX  | $F3A3
    .byte $19 ; |   XX  X| $F3A4
    .byte $19 ; |   XX  X| $F3A5
    .byte $1C ; |   XXX  | $F3A6
    .byte $1F ; |   XXXXX| $F3A7


CaveManGfx_A:
    .byte $3C ; |  XXXX  |
    .byte $14 ; |   X X  |
    .byte $34 ; |  XX X  |
    .byte $1C ; |   XXX  |
    .byte $38 ; |  XXX   |
    .byte $5C ; | X XXX  |
    .byte $16 ; |   X XX |
    .byte $32 ; |  XX  X |
CaveManGfx_B:
    .byte $3C ; |  XXXX  |
    .byte $3C ; |  XXXX  |
    .byte $3C ; |  XXXX  |
    .byte $2C ; |  X XX  |
    .byte $5A ; | X XX X |
    .byte $3C ; |  XXXX  |
    .byte $16 ; |   X XX |
    .byte $30 ; |  XX    |
CaveManGfx_C:
    .byte $3C ; |  XXXX  |
    .byte $3C ; |  XXXX  |
    .byte $3C ; |  XXXX  |
    .byte $18 ; |   XX   |
    .byte $7E ; | XXXXXX |
    .byte $3C ; |  XXXX  |
    .byte $16 ; |   X XX |
    .byte $30 ; |  XX    |
CaveManGfx_D:
    .byte $3C ; |  XXXX  |
    .byte $14 ; |   X X  |
    .byte $34 ; |  XX X  |
    .byte $5C ; | X XXX  |
    .byte $38 ; |  XXX   |
    .byte $1C ; |   XXX  |
    .byte $16 ; |   X XX |
    .byte $30 ; |  XX    |
CaveManGfx_E:
    .byte $3C ; |  XXXX  |
    .byte $3C ; |  XXXX  |
    .byte $3C ; |  XXXX  |
    .byte $2C ; |  X XX  |
    .byte $7E ; | XXXXXX |
    .byte $3C ; |  XXXX  |
    .byte $68 ; | XX X   |
    .byte $0C ; |    XX  |
CaveManGfx_F:
    .byte $3C ; |  XXXX  |
    .byte $3C ; |  XXXX  |
    .byte $3C ; |  XXXX  |
    .byte $5A ; | X XX X |
    .byte $3C ; |  XXXX  |
    .byte $3C ; |  XXXX  |
    .byte $68 ; | XX X   |
    .byte $0C ; |    XX  |
CaveManGfx_G:
    .byte $3C ; |  XXXX  |
    .byte $14 ; |   X X  |
    .byte $34 ; |  XX X  |
    .byte $58 ; | X XX   |
    .byte $7C ; | XXXXX  |
    .byte $1E ; |   XXXX |
    .byte $04 ; |     X  |
    .byte $0C ; |    XX  |
CaveManGfx_H:
    .byte $3C ; |  XXXX  |
    .byte $3C ; |  XXXX  |
    .byte $2C ; |  X XX  |
    .byte $5A ; | X XX X |
    .byte $3C ; |  XXXX  |
    .byte $18 ; |   XX   |
    .byte $3C ; |  XXXX  |
    .byte $00 ; |        |
CaveManGfx_I:
    .byte $00 ; |        |
    .byte $3C ; |  XXXX  |
    .byte $3C ; |  XXXX  |
    .byte $3C ; |  XXXX  |
    .byte $5A ; | X XX X |
    .byte $3C ; |  XXXX  |
    .byte $18 ; |   XX   |
    .byte $3C ; |  XXXX  |

DinoGfx_A:
    .byte $1C ; |   XXX  |
    .byte $36 ; |  XX XX |
    .byte $26 ; |  X  XX |
    .byte $1C ; |   XXX  |
    .byte $7C ; | XXXXX  |
    .byte $3C ; |  XXXX  |
    .byte $16 ; |   X XX |
    .byte $32 ; |  XX  X |
DinoGfx_B:
    .byte $1C ; |   XXX  |
    .byte $2A ; |  X X X |
    .byte $2A ; |  X X X |
    .byte $1C ; |   XXX  |
    .byte $08 ; |    X   |
    .byte $3E ; |  XXXXX |
    .byte $1C ; |   XXX  |
    .byte $32 ; |  XX  X |
DinoGfx_C:
    .byte $1C ; |   XXX  | $F400
    .byte $36 ; |  XX XX | $F401
    .byte $26 ; |  X  XX | $F402
    .byte $1C ; |   XXX  | $F403
    .byte $3E ; |  XXXXX | $F404
    .byte $7E ; | XXXXXX | $F405
    .byte $14 ; |   X X  | $F406
    .byte $34 ; |  XX X  | $F407
DinoGfx_D:
    .byte $1C ; |   XXX  | $F408
    .byte $2A ; |  X X X | $F409
    .byte $2A ; |  X X X | $F40A
    .byte $1C ; |   XXX  | $F40B
    .byte $08 ; |    X   | $F40C
    .byte $3E ; |  XXXXX | $F40D
    .byte $1C ; |   XXX  | $F40E
    .byte $26 ; |  X  XX | $F40F

ColCaveManGfx_A:
    .byte COL_42 ; |  XXXX  |
    .byte COL_48 ; |   X X  |
    .byte COL_48 ; |  XX X  |
    .byte COL_48 ; |   XXX  |
    .byte COL_48 ; |  XXX   |
    .byte COL_16 ; | X XXX  |
    .byte COL_48 ; |   X XX |
    .byte COL_48 ; |  XX  X |
ColCaveManGfx_B:
    .byte COL_42 ; |  XXXX  |
    .byte COL_42 ; |  XXXX  |
    .byte COL_42 ; |  XXXX  |
    .byte COL_42 ; |  X XX  |
    .byte COL_48 ; | X XX X |
    .byte COL_16 ; |  XXXX  |
    .byte COL_48 ; |   X XX |
    .byte COL_48 ; |  XX    |
ColCaveManGfx_C:
    .byte COL_42 ; |  XXXX  |
    .byte COL_48 ; |  XXXX  |
    .byte COL_48 ; |  XXXX  |
    .byte COL_48 ; |   XX   |
    .byte COL_48 ; | XXXXXX |
    .byte COL_16 ; |  XXXX  |
    .byte COL_48 ; |   X XX |
    .byte COL_48 ; |  XX    |
ColCaveManGfx_D:
    .byte COL_42 ; |  XXXX  |
    .byte COL_48 ; |   X X  |
    .byte COL_48 ; |  XX X  |
    .byte COL_48 ; | X XXX  |
    .byte COL_48 ; |  XXX   |
    .byte COL_16 ; |   XXX  |
    .byte COL_48 ; |   X XX |
    .byte COL_48 ; |  XX    |
ColCaveManGfx_E:
    .byte COL_42 ; |  XXXX  |
    .byte COL_42 ; |  XXXX  |
    .byte COL_42 ; |  XXXX  |
    .byte COL_42 ; |  X XX  |
    .byte COL_48 ; | XXXXXX |
    .byte COL_16 ; |  XXXX  |
    .byte COL_48 ; | XX X   |
    .byte COL_48 ; |    XX  |
ColCaveManGfx_F:
    .byte COL_42 ; |  XXXX  |
    .byte COL_48 ; |  XXXX  |
    .byte COL_48 ; |  XXXX  |
    .byte COL_48 ; | X XX X |
    .byte COL_48 ; |  XXXX  |
    .byte COL_16 ; |  XXXX  |
    .byte COL_48 ; | XX X   |
    .byte COL_48 ; |    XX  |
ColCaveManGfx_G:
    .byte COL_42 ; |  XXXX  |
    .byte COL_48 ; |   X X  |
    .byte COL_48 ; |  XX X  |
    .byte COL_48 ; | X XX   |
    .byte COL_48 ; | XXXXX  |
    .byte COL_16 ; |   XXXX |
    .byte COL_48 ; |     X  |
    .byte COL_48 ; |    XX  |
ColCaveManGfx_H:
    .byte COL_42 ; |  XXXX  |
    .byte COL_42 ; |  XXXX  |
    .byte COL_42 ; |  X XX  |
    .byte COL_48 ; | X XX X |
    .byte COL_16 ; |  XXXX  |
    .byte COL_48 ; |   XX   |
    .byte COL_48 ; |  XXXX  |
    .byte COL_00 ; |        |
ColCaveManGfx_I:
    .byte COL_00 ; |        |
    .byte COL_42 ; |  XXXX  |
    .byte COL_48 ; |  XXXX  |
    .byte COL_48 ; |  XXXX  |
    .byte COL_48 ; | X XX X |
    .byte COL_16 ; |  XXXX  |
    .byte COL_48 ; |   XX   |
    .byte COL_48 ; |  XXXX  |

LF458:
    .byte $00 ; |        | $F458   0

    .byte $E0 ; |XXX     | $F459   1
    .byte $0E ; |    XXX | $F45A   2
    .byte $EE ; |XXX XXX | $F45B   3

    .byte $07 ; |     XXX| $F45C   4
    .byte 0,0,0
    .byte $70 ; | XXX    | $F460   8
    .byte 0,0,0
    .byte $77 ; | XXX XXX| $F464   12
    .byte 0,0,0

    .byte $E0 ; |XXX     | $F468   16

LF469:
    .byte $00 ; |        | $F469   0

    .byte $A0 ; |X X     | $F46A   1
    .byte $0A ; |    X X | $F46B   2
    .byte $AA ; |X X X X | $F46C   3

    .byte $05 ; |     X X| $F46D   4
    .byte 0,0,0
    .byte $50 ; | X X    | $F471   8
    .byte 0,0,0
    .byte $55 ; | X X X X| $F475   12
    .byte 0,0,0

    .byte $A0 ; |X X     | $F479   16


    .byte $02 ; |      X | $F47A
    .byte $10 ; |   X    | $F47B
    .byte $1A ; |   XX X | $F47C
    .byte $1E ; |   XXXX | $F47D
    .byte $02 ; |      X | $F47E
    .byte $00 ; |        | $F47F
    .byte $0E ; |    XXX | $F480
    .byte $1A ; |   XX X | $F481
    .byte $00 ; |        | $F482
    .byte $0A ; |    X X | $F483
    .byte $1A ; |   XX X | $F484
    .byte $0A ; |    X X | $F485
    .byte $0B ; |    X XX| $F486
    .byte $0B ; |    X XX| $F487
    .byte $02 ; |      X | $F488
    .byte $08 ; |    X   | $F489
LF48A:
    .byte $21 ; |  X    X| $F48A   RESPx and HMPx
    .byte $73 ; | XXX  XX| $F48B
    .byte $64 ; | XX  X  | $F48C
    .byte $55 ; | X X X X| $F48D
    .byte $36 ; |  XX XX | $F48E
    .byte $37 ; |  XX XXX| $F48F
    .byte $28 ; |  X X   | $F490
    .byte $19 ; |   XX  X| $F491
    .byte $0A ; |    X X | $F492
    .byte $0B ; |    X XX| $F493
LF494:
    .byte $3C ; |  XXXX  | $F494
    .byte $62 ; | XX   X | $F495
    .byte $66 ; | XX  XX | $F496
    .byte $6A ; | XX X X | $F497
    .byte $72 ; | XXX  X | $F498
    .byte $62 ; | XX   X | $F499
    .byte $3C ; |  XXXX  | $F49A
    .byte $00 ; |        | $F49B
    .byte $38 ; |  XXX   | $F49C
    .byte $18 ; |   XX   | $F49D
    .byte $18 ; |   XX   | $F49E
    .byte $18 ; |   XX   | $F49F
    .byte $18 ; |   XX   | $F4A0
    .byte $18 ; |   XX   | $F4A1
    .byte $3C ; |  XXXX  | $F4A2
    .byte $00 ; |        | $F4A3
    .byte $3C ; |  XXXX  | $F4A4
    .byte $62 ; | XX   X | $F4A5
    .byte $02 ; |      X | $F4A6
    .byte $06 ; |     XX | $F4A7
    .byte $18 ; |   XX   | $F4A8
    .byte $60 ; | XX     | $F4A9
    .byte $7E ; | XXXXXX | $F4AA
    .byte $00 ; |        | $F4AB
    .byte $3C ; |  XXXX  | $F4AC
    .byte $62 ; | XX   X | $F4AD
    .byte $02 ; |      X | $F4AE
    .byte $04 ; |     X  | $F4AF
    .byte $02 ; |      X | $F4B0
    .byte $62 ; | XX   X | $F4B1
    .byte $3C ; |  XXXX  | $F4B2
    .byte $00 ; |        | $F4B3
    .byte $0C ; |    XX  | $F4B4
    .byte $1C ; |   XXX  | $F4B5
    .byte $34 ; |  XX X  | $F4B6
    .byte $64 ; | XX  X  | $F4B7
    .byte $7E ; | XXXXXX | $F4B8
    .byte $04 ; |     X  | $F4B9
    .byte $04 ; |     X  | $F4BA
    .byte $00 ; |        | $F4BB
    .byte $7E ; | XXXXXX | $F4BC
    .byte $60 ; | XX     | $F4BD
    .byte $7C ; | XXXXX  | $F4BE
    .byte $02 ; |      X | $F4BF
    .byte $02 ; |      X | $F4C0
    .byte $62 ; | XX   X | $F4C1
    .byte $3C ; |  XXXX  | $F4C2
    .byte $00 ; |        | $F4C3
    .byte $1E ; |   XXXX | $F4C4
    .byte $30 ; |  XX    | $F4C5
    .byte $60 ; | XX     | $F4C6
    .byte $7C ; | XXXXX  | $F4C7
    .byte $62 ; | XX   X | $F4C8
    .byte $62 ; | XX   X | $F4C9
    .byte $3C ; |  XXXX  | $F4CA
    .byte $00 ; |        | $F4CB
    .byte $7E ; | XXXXXX | $F4CC
    .byte $06 ; |     XX | $F4CD
    .byte $0C ; |    XX  | $F4CE
    .byte $18 ; |   XX   | $F4CF
    .byte $30 ; |  XX    | $F4D0
    .byte $30 ; |  XX    | $F4D1
    .byte $30 ; |  XX    | $F4D2
    .byte $00 ; |        | $F4D3
    .byte $3C ; |  XXXX  | $F4D4
    .byte $62 ; | XX   X | $F4D5
    .byte $62 ; | XX   X | $F4D6
    .byte $3C ; |  XXXX  | $F4D7
    .byte $62 ; | XX   X | $F4D8
    .byte $62 ; | XX   X | $F4D9
    .byte $3C ; |  XXXX  | $F4DA
    .byte $00 ; |        | $F4DB
    .byte $3C ; |  XXXX  | $F4DC
    .byte $62 ; | XX   X | $F4DD
    .byte $62 ; | XX   X | $F4DE
    .byte $3E ; |  XXXXX | $F4DF
    .byte $02 ; |      X | $F4E0
    .byte $04 ; |     X  | $F4E1
    .byte $78 ; | XXXX   | $F4E2
    .byte $00 ; |        | $F4E3
    .byte $00 ; |        | $F4E4
    .byte $00 ; |        | $F4E5
    .byte $00 ; |        | $F4E6
    .byte $00 ; |        | $F4E7
    .byte $00 ; |        | $F4E8
    .byte $00 ; |        | $F4E9
    .byte $00 ; |        | $F4EA
    .byte $00 ; |        | $F4EB

;----------------------------------------------
;                        XX   XX
;                         X   X
;    XXXXXX XX X X  X   X XX XX  XX    X   X
;     X X  X   X X X X X X X X X X  X X X X X
;     X XX X   XXX X X X X X X X X  X X X X X
;     X X  X   X X X X X X XXX X  X X X X X X
;     X XXX XX X X X X  X   X  X XX X  X  X X
;                           X

TechnoVisionLogo_A:
    .byte $00 ; |        |
    .byte $00 ; |        |
    .byte $FD ; |XXXXXX X|
    .byte $52 ; | X X  X |
    .byte $5A ; | X XX X |
    .byte $52 ; | X X  X |
    .byte $5D ; | X XXX X|
    .byte $00 ; |        |
TechnoVisionLogo_B:
    .byte $00 ; |        |
    .byte $00 ; |        |
    .byte $A9 ; |X X X  X|
    .byte $2A ; |  X X X |
    .byte $3A ; |  XXX X |
    .byte $2A ; |  X X X |
    .byte $AA ; |X X X X |
    .byte $00 ; |        |
TechnoVisionLogo_C:
    .byte $0C ; |    XX  |
    .byte $04 ; |     X  |
    .byte $16 ; |   X XX |
    .byte $AA ; |X X X X |
    .byte $AA ; |X X X X |
    .byte $AB ; |X X X XX|
    .byte $91 ; |X  X   X|
    .byte $01 ; |       X|
TechnoVisionLogo_D:
    .byte $60 ; | XX     |
    .byte $40 ; | X      |
    .byte $CC ; |XX  XX  |
    .byte $A9 ; |X X X  X|
    .byte $A9 ; |X X X  X|
    .byte $A5 ; |X X  X X|
    .byte $2D ; |  X XX X|
    .byte $00 ; |        |
TechnoVisionLogo_E:
    .byte $00 ; |        |
    .byte $00 ; |        |
    .byte $22 ; |  X   X |
    .byte $55 ; | X X X X|
    .byte $55 ; | X X X X|
    .byte $55 ; | X X X X|
    .byte $25 ; |  X  X X|
    .byte $00 ; |        |

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MoveDinoUp:
    ldx    indexDinosaurs
    lda    dinoPositions,X
    sec
    sbc    #$10
    sta    dinoPositions,X
    lda    #<DinoGfx_B
    sta    dinoLoPtr,X
    lda    ram_D8,X              ; 4
    and    #DIR_02
    ora    #DIR_10
    sta    ram_D8,X              ; 4
    rts                          ; 6

MoveDinoDown:
    ldx    indexDinosaurs
    lda    dinoPositions,X
    clc
    adc    #$10
    sta    dinoPositions,X
    lda    #<DinoGfx_B
    sta    dinoLoPtr,X
    lda    ram_D8,X              ; 4
    and    #DIR_01
    ora    #DIR_20
    sta    ram_D8,X              ; 4
    rts                          ; 6

MoveDinoLeft:
    ldx    indexDinosaurs
    lda    dinoPositions,X
    sec
    sbc    #1
    sta    dinoPositions,X
    lda    #NO_REFLECT
    sta    reflectDinoGfx,X
    lda    #<DinoGfx_A
    sta    dinoLoPtr,X
    lda    ram_D8,X              ; 4
    and    #DIR_08
    ora    #DIR_40
    sta    ram_D8,X              ; 4
    rts                          ; 6

MoveDinoRight:
    ldx    indexDinosaurs
    lda    dinoPositions,X
    clc
    adc    #1
    sta    dinoPositions,X
    lda    #REFLECT_GFX
    sta    reflectDinoGfx,X
    lda    #<DinoGfx_A
    sta    dinoLoPtr,X
    lda    ram_D8,X              ; 4
    and    #DIR_04
    ora    #DIR_80
    sta    ram_D8,X              ; 4
    rts                          ; 6

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LF574:
    lda    ram_B2                ; 3
    asl                          ; 2
    tax                          ; 2
    dex                          ; 2
    dex                          ; 2
    lda    ram_B3                ; 3
    cmp    #$06                  ; 2
    bcc    LF584                 ; 2
    inx                          ; 2
    sec                          ; 2
    sbc    #$05                  ; 2
LF584:
    clc                          ; 2
    adc    #$03                  ; 2
    stx    ram_B2                ; 3
    sta    ram_B3                ; 3
    rts                          ; 6

LF58C:
    lda    cavemanYpos
    asl                          ; 2
    tax                          ; 2
    dex                          ; 2
    dex                          ; 2
    lda    cavemanXpos
    cmp    #$06                  ; 2
    bcc    LF59C                 ; 2
    inx                          ; 2
    sec                          ; 2
    sbc    #$05                  ; 2
LF59C:
    clc                          ; 2
    adc    #$03                  ; 2
    tay                          ; 2
    rts                          ; 6

LF5A1:
    lda    frameCounter          ; 3
    and    #$07                  ; 2
    cmp    #$01                  ; 2
    beq    LF5AA                 ; 2
    rts                          ; 6

LF5AA:
    lda    #$4B                  ; 2
    sec                          ; 2
    sbc    ram_82                ; 3
    bne    LF5B4                 ; 2
    jmp    LFC65                 ; 3

LF5B4:
    cmp    #$0F                  ; 2
    beq    LF5B9                 ; 2
    rts                          ; 6

LF5B9:
    lda    #COL_PF_BLOCKS_BLUE
    sta    ram_DC                ; 3
    rts                          ; 6

LF5BE:
    lda    slidingBlock
    bpl    LF5C3                 ; if not sliding
    rts

LF5C3:
    lda    ram_DF                ; 3
    bpl    LF5CD                 ; 2
    lda    frameCounter          ; 3
    and    #$0F                  ; 2
    sta    ram_DF                ; 3
LF5CD:
    eor    frameCounter          ; 3
    and    #$0F                  ; 2
    beq    LF5D4                 ; 2
    rts                          ; 6

LF5D4:
    lda    ram_E6                ; 3
    beq    LF5DD                 ; 2
    lda    #$00                  ; 2
    sta    ram_E6                ; 3
    rts                          ; 6

LF5DD:
    lda    ram_D4                ; 3
    cmp    #$0F                  ; 2
    bne    LF5E8                 ; 2
    lda    #$80                  ; 2
    sta    ram_DF                ; 3
    rts                          ; 6

LF5E8:
    lda    #$01                  ; 2
    sta    ram_E6                ; 3
    dec    frameCounter          ; 5
    jsr    LF58C                 ; 6
    lda    ram_D4                ; 3
    cmp    #$0E                  ; 2
    bne    LF639                 ; 2+1
    cpx    #$02                  ; 2
    bcs    LF5FE                 ; 2
    jmp    GotoLF049             ; 3

LF5FE:
    dex                          ; 2
    dex                          ; 2
    lda    stoneOrder,X
LF602:
    asl                          ; 2
    dey                          ; 2
    bne    LF602                 ; 2
    bcc    LF60B                 ; 2
    jmp    GotoLF049             ; 3

LF60B:
    dec    cavemanYpos
    lda    cavemanYpos
    and    #$01                  ; 2
    beq    LF626                 ; 2
    CAVEMAN_PTRS  CaveManGfx_B, ColCaveManGfx_B
    jmp    GotoLF049

LF626:
    CAVEMAN_PTRS  CaveManGfx_E, ColCaveManGfx_E
    jmp    GotoLF049

LF639:
    cmp    #$0D                  ; 2
    bne    LF67F                 ; 2
    cpx    #$0E                  ; 2
    bcc    LF644                 ; 2
    jmp    GotoLF049             ; 3

LF644:
    inx                          ; 2
    inx                          ; 2
    lda    stoneOrder,X
LF648:
    asl                          ; 2
    dey                          ; 2
    bne    LF648                 ; 2
    bcc    LF651                 ; 2
    jmp    GotoLF049             ; 3

LF651:
    inc    cavemanYpos
    lda    cavemanYpos
    and    #$01                  ; 2
    beq    LF66C                 ; 2
    CAVEMAN_PTRS  CaveManGfx_C, ColCaveManGfx_C
    jmp    GotoLF049

LF66C:
    CAVEMAN_PTRS  CaveManGfx_F, ColCaveManGfx_F
    jmp    GotoLF049

LF67F:
    cmp    #$0B                  ; 2
    bne    LF6D1                 ; 2
    cpy    #$05                  ; 2
    bcs    LF693                 ; 2
    txa                          ; 2
    and    #$01                  ; 2
    bne    LF68F                 ; 2
    jmp    GotoLF049             ; 3

LF68F:
    dex                          ; 2
    lda    #$09                  ; 2
    tay                          ; 2
LF693:
    dey                          ; 2
    lda    stoneOrder,X
LF696:
    asl                          ; 2
    dey                          ; 2
    bne    LF696                 ; 2
    bcc    LF69F                 ; 2
    jmp    GotoLF049             ; 3

LF69F:
    dec    cavemanXpos
    lda    #NO_REFLECT
    sta    reflectCaveman
    lda    cavemanXpos
    and    #$01                  ; 2
    bne    LF6BE                 ; 2
    CAVEMAN_PTRS  CaveManGfx_A, ColCaveManGfx_A
    jmp    GotoLF049

LF6BE:
    CAVEMAN_PTRS  CaveManGfx_D, ColCaveManGfx_D
    jmp    GotoLF049

LF6D1:
    cmp    #$07                  ; 2
    beq    LF6D6                 ; 2
    rts                          ; 6

LF6D6:
    cpy    #$08                  ; 2
    bcc    LF6E6                 ; 2
    txa                          ; 2
    and    #$01                  ; 2
    beq    LF6E2                 ; 2
    jmp    GotoLF049             ; 3

LF6E2:
    inx                          ; 2
    lda    #$03                  ; 2
    tay                          ; 2
LF6E6:
    iny                          ; 2
    lda    stoneOrder,X
LF6E9:
    asl                          ; 2
    dey                          ; 2
    bne    LF6E9                 ; 2
    bcc    LF6F2                 ; 2
    jmp    GotoLF049             ; 3

LF6F2:
    inc    cavemanXpos
    lda    #REFLECT_GFX
    sta    reflectCaveman
    lda    cavemanXpos
    and    #$01                  ; 2
    bne    LF711                 ; 2+1
    CAVEMAN_PTRS  CaveManGfx_A, ColCaveManGfx_A
    jmp    GotoLF049

LF711:
    CAVEMAN_PTRS  CaveManGfx_D, ColCaveManGfx_D
    jmp    GotoLF049

LF724:
    lda    slidingBlock
    bpl    LF729                 ; if not sliding
    rts

LF729:
    lda    frameCounter          ; 3
    ldx    playerNum             ; 3
    and    difficultyP0,X
    cmp    #$01                  ; 2
    beq    LF734                 ; 2
    rts                          ; 6

LF734:
    ldy    #4
LF736:
    inc    indexDinosaurs
    lda    indexDinosaurs
    and    #DINO_NUM_MASK        ; no more then 4 dinosaurs
    tax                          ; 2
    lda    dinoColors,X
    bne    LF744                 ; 2
    dey                          ; 2
    bne    LF736                 ; 2
LF744:
    stx    indexDinosaurs
    jsr    LF7C9                 ; 6
    jsr    LF574                 ; 6
    lda    #$F0                  ; 2
    sta    ram_B4                ; 3
    ldx    ram_B2                ; 3
    ldy    ram_B3                ; 3
    cpx    #$02                  ; 2
    bcs    LF75A                 ; 2
    bcc    LF76A                 ; 3   always branch

LF75A:
    dex                          ; 2
    dex                          ; 2
    lda    stoneOrder,X
LF75E:
    asl                          ; 2
    dey                          ; 2
    bne    LF75E                 ; 2
    bcs    LF76A                 ; 2
    lda    #$F1                  ; 2
    ora    ram_B4                ; 3
    sta    ram_B4                ; 3
LF76A:
    ldx    ram_B2                ; 3
    ldy    ram_B3                ; 3
    cpx    #$0E                  ; 2
    bcc    LF774                 ; 2
    bcs    LF784                 ; 3   always branch

LF774:
    inx                          ; 2
    inx                          ; 2
    lda    stoneOrder,X
LF778:
    asl                          ; 2
    dey                          ; 2
    bne    LF778                 ; 2
    bcs    LF784                 ; 2
    lda    #$F2                  ; 2
    ora    ram_B4                ; 3
    sta    ram_B4                ; 3
LF784:
    ldx    ram_B2                ; 3
    ldy    ram_B3                ; 3
    cpy    #$05                  ; 2
    bcs    LF797                 ; 2
    txa                          ; 2
    and    #$01                  ; 2
    bne    LF793                 ; 2
    beq    LF7A6                 ; 3   always branch

LF793:
    dex                          ; 2
    lda    #$09                  ; 2
    tay                          ; 2
LF797:
    dey                          ; 2
    lda    stoneOrder,X
LF79A:
    asl                          ; 2
    dey                          ; 2
    bne    LF79A                 ; 2
    bcs    LF7A6                 ; 2
    lda    #$F4                  ; 2
    ora    ram_B4                ; 3
    sta    ram_B4                ; 3
LF7A6:
    ldx    ram_B2                ; 3
    ldy    ram_B3                ; 3
    cpy    #$08                  ; 2
    bcc    LF7B9                 ; 2
    txa                          ; 2
    and    #$01                  ; 2
    beq    LF7B5                 ; 2
    bne    LF7C8                 ; 3   always branch

LF7B5:
    inx                          ; 2
    lda    #$03                  ; 2
    tay                          ; 2
LF7B9:
    iny                          ; 2
    lda    stoneOrder,X
LF7BC:
    asl                          ; 2
    dey                          ; 2
    bne    LF7BC                 ; 2
    bcs    LF7C8                 ; 2
    lda    #$F8                  ; 2
    ora    ram_B4                ; 3
    sta    ram_B4                ; 3
LF7C8:
    rts                          ; 6

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LF7C9; SUBROUTINE
    ldx    indexDinosaurs
    lda    dinoPositions,X
    lsr                          ; 2
    lsr                          ; 2
    lsr                          ; 2
    lsr                          ; 2
    sta    ram_B2                ; 3
    lda    #$0F                  ; 2
    and    dinoPositions,X
    sta    ram_B3                ; 3
    rts                          ; 6

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LF7DA:
    lda    frameCounter          ; 3
    and    #$0F                  ; 2
    cmp    #$06                  ; 2
    beq    LF7E3                 ; 2
    rts                          ; 6

LF7E3:
    lda    slidingBlock
    bpl    LF7E8                 ; if not sliding
    rts

LF7E8:
    lda    #$01                  ; 2
    sta    ram_C8                ; 3
    lda    ram_D5                ; 3
    bpl    LF7F5                 ; 2
    lda    #$00                  ; 2
    sta    AUDV1                 ; 3
    rts                          ; 6

LF7F5:
    lda    ram_D4                ; 3
    ora    #$F0                  ; 2
    cmp    #$FF                  ; 2
    bne    LF802                 ; 2+1
    lda    #$00                  ; 2
    sta    AUDV1                 ; 3
    rts                          ; 6

LF802:
    ldy    #$00                  ; 2
    sty    AUDV1                 ; 3
    sty    ram_DD                ; 3
    and    #~BLOCK_SLIDING_FLAG
    sta    slidingBlock          ; stop block sliding, player can move again?
    cmp    #$7E                  ; 2
    bne    LF813                 ; 2
    jmp    LF824                 ; 3

LF813:
    cmp    #$7D                  ; 2
    bne    LF81A                 ; 2
    jmp    LF860                 ; 3

LF81A:
    cmp    #$7B                  ; 2
    bne    LF821                 ; 2
    jmp    LF8DE                 ; 3

LF821:
    jmp    LF89C                 ; 3

LF824:
    lda    cavemanYpos
    cmp    #TOP_YPOS_CAVEMAN
    bne    LF82B
    rts

LF82B:
    jsr    LF58C                 ; 6
    dex                          ; 2
    dex                          ; 2
    stx    ram_B2                ; 3
    sty    ram_B3                ; 3
    lda    stoneOrder,X
LF836:
    asl                          ; 2
    dey                          ; 2
    bne    LF836                 ; 2
    bcs    .pushBlockUp
    rts

.pushBlockUp:
    CAVEMAN_PTRS  CaveManGfx_H, ColCaveManGfx_H
    DO_BLOCK_SLIDE
    rts

LF860:
    lda    cavemanYpos
    cmp    #BOTTOM_YPOS_CAVEMAN
    bne    LF867
    rts

LF867:
    jsr    LF58C                 ; 6
    inx                          ; 2
    inx                          ; 2
    stx    ram_B2                ; 3
    sty    ram_B3                ; 3
    lda    stoneOrder,X
LF872:
    asl                          ; 2
    dey                          ; 2
    bne    LF872                 ; 2
    bcs    .pushBlockDown
    rts

.pushBlockDown:
    CAVEMAN_PTRS  CaveManGfx_I, ColCaveManGfx_I
    DO_BLOCK_SLIDE
    rts

LF89C:
    lda    cavemanXpos
    cmp    #$0A                  ; 2
    bne    LF8A3                 ; 2
    rts                          ; 6

LF8A3:
    inc    cavemanXpos
    jsr    LF58C                 ; 6
    dec    cavemanXpos
    stx    ram_B2                ; 3
    sty    ram_B3                ; 3
    lda    stoneOrder,X
LF8B0:
    asl                          ; 2
    dey                          ; 2
    bne    LF8B0                 ; 2
    bcs    .pushBlockRight
    rts

.pushBlockRight:
    CAVEMAN_PTRS  CaveManGfx_G, ColCaveManGfx_G
    lda    #REFLECT_GFX
    sta    reflectCaveman
    DO_BLOCK_SLIDE
    rts

LF8DE:
    lda    cavemanXpos
    cmp    #$01                  ; 2
    bne    LF8E5                 ; 2
    rts                          ; 6

LF8E5:
    dec    cavemanXpos
    jsr    LF58C                 ; 6
    inc    cavemanXpos
    stx    ram_B2                ; 3
    sty    ram_B3                ; 3
    lda    stoneOrder,X
LF8F2:
    asl                          ; 2
    dey                          ; 2
    bne    LF8F2                 ; 2
    bcs    .pushBlockLeft
    rts

.pushBlockLeft:
    CAVEMAN_PTRS  CaveManGfx_G, ColCaveManGfx_G
    lda    #NO_REFLECT
    sta    reflectCaveman
    DO_BLOCK_SLIDE
    rts

LF920:
    lda    frameCounter          ; 3
    and    #$07                  ; 2
    cmp    #$06                  ; 2
    beq    LF929                 ; 2
    rts                          ; 6

LF929:
    lda    slidingBlock
    bmi    LF92E                 ; if block is sliding
    rts

LF92E:
    ldy    #$07                  ; 2
    sty    AUDF1                 ; 3
    cmp    #$FE                  ; 2
    bne    LF939                 ; 2
    jmp    LF94A                 ; 3

LF939:
    cmp    #$FD                  ; 2
    bne    LF940                 ; 2
    jmp    LF984                 ; 3

LF940:
    cmp    #$FB                  ; 2
    bne    LF947                 ; 2
    jmp    LF9BE                 ; 3

LF947:
    jmp    LFA0F                 ; 3

LF94A:
    ldx    ram_B2                ; 3
    ldy    ram_B3                ; 3
    cpx    #$02                  ; 2
    bcs    LF955                 ; 2
    jmp    LFA60                 ; 3

LF955:
    dex                          ; 2
    dex                          ; 2
    lda    stoneOrder,X
LF959:
    asl                          ; 2
    dey                          ; 2
    bne    LF959                 ; 2
    bcc    LF962                 ; 2
    jmp    LFA60                 ; 3

LF962:
    ldx    ram_B2                ; 3
    ldy    ram_B3                ; 3
    lda    #$80                  ; 2
    dey                          ; 2
LF969:
    lsr                          ; 2
    dey                          ; 2
    bne    LF969                 ; 2
    sta    ram_AD                ; 3
    eor    #$FF                  ; 2
    and    stoneOrder,X
    sta    stoneOrder,X
    dex                          ; 2
    dex                          ; 2
    stx    ram_B2                ; 3
    lda    ram_AD                ; 3
    ora    stoneOrder,X
    sta    stoneOrder,X
    lda    #$00                  ; 2
    sta    ram_C8                ; 3
    rts                          ; 6

LF984:
    ldx    ram_B2                ; 3
    ldy    ram_B3                ; 3
    cpx    #$0E                  ; 2
    bcc    LF98F                 ; 2
    jmp    LFA60                 ; 3

LF98F:
    inx                          ; 2
    inx                          ; 2
    lda    stoneOrder,X
LF993:
    asl                          ; 2
    dey                          ; 2
    bne    LF993                 ; 2
    bcc    LF99C                 ; 2
    jmp    LFA60                 ; 3

LF99C:
    ldx    ram_B2                ; 3
    ldy    ram_B3                ; 3
    lda    #$80                  ; 2
    dey                          ; 2
LF9A3:
    lsr                          ; 2
    dey                          ; 2
    bne    LF9A3                 ; 2
    sta    ram_AD                ; 3
    eor    #$FF                  ; 2
    and    stoneOrder,X
    sta    stoneOrder,X
    inx                          ; 2
    inx                          ; 2
    stx    ram_B2                ; 3
    lda    ram_AD                ; 3
    ora    stoneOrder,X
    sta    stoneOrder,X
    lda    #$00                  ; 2
    sta    ram_C8                ; 3
    rts                          ; 6

LF9BE:
    ldx    ram_B2                ; 3
    ldy    ram_B3                ; 3
    cpy    #$04                  ; 2
    bne    LF9D2                 ; 2
    lda    ram_B2                ; 3
    and    #$01                  ; 2
    bne    LF9CF                 ; 2
    jmp    LFA60                 ; 3

LF9CF:
    dex                          ; 2
    ldy    #$09                  ; 2
LF9D2:
    dey                          ; 2
    lda    stoneOrder,X
LF9D5:
    asl                          ; 2
    dey                          ; 2
    bne    LF9D5                 ; 2
    bcc    LF9DE                 ; 2
    jmp    LFA60                 ; 3

LF9DE:
    ldx    ram_B2                ; 3
    ldy    ram_B3                ; 3
    lda    #$80                  ; 2
    dey                          ; 2
LF9E5:
    lsr                          ; 2
    dey                          ; 2
    bne    LF9E5                 ; 2
    eor    #$FF                  ; 2
    and    stoneOrder,X
    sta    stoneOrder,X
    ldy    ram_B3                ; 3
    ldx    ram_B2                ; 3
    cpy    #$04                  ; 2
    bne    LF9FC                 ; 2
    dex                          ; 2
    stx    ram_B2                ; 3
    ldy    #$09                  ; 2
LF9FC:
    dey                          ; 2
    sty    ram_B3                ; 3
    lda    #$80                  ; 2
    dey                          ; 2
LFA02:
    lsr                          ; 2
    dey                          ; 2
    bne    LFA02                 ; 2
    ora    stoneOrder,X
    sta    stoneOrder,X
    lda    #$00                  ; 2
    sta    ram_C8                ; 3
    rts                          ; 6

LFA0F:
    ldx    ram_B2                ; 3
    ldy    ram_B3                ; 3
    cpy    #$08                  ; 2
    bne    LFA23                 ; 2
    lda    ram_B2                ; 3
    and    #$01                  ; 2
    beq    LFA20                 ; 2
    jmp    LFA60                 ; 3

LFA20:
    inx                          ; 2
    ldy    #$03                  ; 2
LFA23:
    iny                          ; 2
    lda    stoneOrder,X
LFA26:
    asl                          ; 2
    dey                          ; 2
    bne    LFA26                 ; 2
    bcc    LFA2F                 ; 2
    jmp    LFA60                 ; 3

LFA2F:
    ldx    ram_B2                ; 3
    ldy    ram_B3                ; 3
    lda    #$80                  ; 2
    dey                          ; 2
LFA36:
    lsr                          ; 2
    dey                          ; 2
    bne    LFA36                 ; 2
    eor    #$FF                  ; 2
    and    stoneOrder,X
    sta    stoneOrder,X
    ldy    ram_B3                ; 3
    ldx    ram_B2                ; 3
    cpy    #$08                  ; 2
    bne    LFA4D                 ; 2
    inx                          ; 2
    stx    ram_B2                ; 3
    ldy    #$03                  ; 2
LFA4D:
    iny                          ; 2
    sty    ram_B3                ; 3
    lda    #$80                  ; 2
    dey                          ; 2
LFA53:
    lsr                          ; 2
    dey                          ; 2
    bne    LFA53                 ; 2
    ora    stoneOrder,X
    sta    stoneOrder,X
    lda    #$00                  ; 2
    sta    ram_C8                ; 3
    rts                          ; 6

LFA60:
    lda    ram_C8                ; 3
    beq    LFA8A                 ; 2
    lda    frameCounter          ; 3
    and    #$1F                  ; 2
    cmp    #$06                  ; 2
    bne    LFA8A                 ; 2
    ldx    ram_B2                ; 3
    ldy    ram_B3                ; 3
    lda    #$80                  ; 2
    dey                          ; 2
LFA73:
    lsr                          ; 2
    dey                          ; 2
    bne    LFA73                 ; 2
    eor    #$FF                  ; 2
    and    stoneOrder,X
    sta    stoneOrder,X
    jsr    LFB10                 ; 6
    lda    #$05                  ; 2
    sta    AUDF1                 ; 3
    lda    #$0B                  ; 2
    sta    AUDV1                 ; 3
    bne    LFA8E                 ; 3   always branch

LFA8A:
    lda    #$00                  ; 2
    sta    AUDV1                 ; 3
LFA8E:
    lda    #BLOCK_NOT_SLIDING
    sta    slidingBlock
    rts

LFA93:
    lda    frameCounter          ; 3
    and    #$07                  ; 2
    cmp    #$07                  ; 2
    beq    LFA9C                 ; 2
    rts                          ; 6

LFA9C:
    lda    slidingBlock
    bmi    LFAA1                 ; if block is sliding
    rts

LFAA1:
    ldx    #3
LFAA3:
    lda    dinoColors,X
    beq    LFAE2                 ; dinosaur is dead
    lda    dinoPositions,X
    and    #$0F                  ; 2
    sta    ram_AD                ; 3
    lda    ram_B2                ; 3
    lsr                          ; 2
    bcs    LFAB6                 ; 2
    lda    #$00                  ; 2
    beq    LFAB8                 ; 3   always branch

LFAB6:
    lda    #$05                  ; 2
LFAB8:
    clc                          ; 2
    adc    ram_B3                ; 3
    sec                          ; 2
    sbc    #$03                  ; 2
    cmp    ram_AD                ; 3
    bne    LFAE2                 ; 2
    lda    dinoPositions,X
    lsr                          ; 2
    lsr                          ; 2
    lsr                          ; 2
    lsr                          ; 2
    sta    ram_AD                ; 3
    dec    ram_AD                ; 5
    lda    ram_B2                ; 3
    lsr                          ; 2
    cmp    ram_AD                ; 3
    bne    LFAE2                 ; 2
    lda    #DEAD_DINOSAUR_FLAG   ; stored as a marker to skip this dinosaur...
    sta    dinoColors,X
    lda    #$01                  ; 2
    sta    dinoPositions,X
    lda    #$01                  ; 2
    sta    AUDF1                 ; 3
    jsr    LFAE6                 ; 6
LFAE2:
    dex                          ; 2
    bpl    LFAA3                 ; 2
    rts                          ; 6

LFAE6:
    sed                          ; 2
    clc                          ; 2
    ldy    playerNum             ; 3
    lda.wy ram_C9,Y              ; 4
    ldy    ram_DD                ; 3
    adc    LFB08,Y               ; 4
    ldy    playerNum             ; 3
    sta.wy ram_C9,Y              ; 5
    lda.wy ram_CB,Y              ; 4
    ldy    ram_DD                ; 3
    adc    LFB0C,Y               ; 4
    ldy    playerNum             ; 3
    sta.wy ram_CB,Y              ; 5
    cld                          ; 2
    inc    ram_DD                ; 5
    rts                          ; 6

LFB08:
    .byte $10 ; |   X    | $FB08
    .byte $40 ; | X      | $FB09
    .byte $60 ; | XX     | $FB0A
    .byte $40 ; | X      | $FB0B
LFB0C:
    .byte $00 ; |        | $FB0C
    .byte $00 ; |        | $FB0D
    .byte $01 ; |       X| $FB0E
    .byte $06 ; |     XX | $FB0F

LFB10:
    sed                          ; 2
    clc                          ; 2
    ldy    playerNum             ; 3
    lda.wy ram_C9,Y              ; 4
    adc    #$01                  ; 2
    sta.wy ram_C9,Y              ; 5
    lda.wy ram_CB,Y              ; 4
    adc    #$00                  ; 2
    sta.wy ram_CB,Y              ; 5
    cld                          ; 2
    rts                          ; 6

LFB26:
    lda    frameCounter          ; 3
    and    #$07                  ; 2
    cmp    #$07                  ; 2
    beq    LFB2F                 ; 2
    rts                          ; 6

LFB2F:
    ldy    playerNum             ; 3
    lda.wy ram_C9,Y              ; 4
    and    #$0F                  ; 2
    asl                          ; 2
    asl                          ; 2
    asl                          ; 2
    adc    #$94                  ; 2
    sta    ram_90                ; 3
    lda.wy ram_C9,Y              ; 4
    and    #$F0                  ; 2
    lsr                          ; 2
    adc    #$94                  ; 2
    sta    ram_8E                ; 3
    lda.wy ram_CB,Y              ; 4
    and    #$0F                  ; 2
    asl                          ; 2
    asl                          ; 2
    asl                          ; 2
    adc    #$94                  ; 2
    sta    ram_8C                ; 3
    lda.wy ram_CB,Y              ; 4
    and    #$F0                  ; 2
    lsr                          ; 2
    adc    #$94                  ; 2
    sta    ram_8A                ; 3
    rts                          ; 6

LFB5E:
    lda    ram_D0                ; 3
    bne    LFB9B                 ; 2
    lda    frameCounter          ; 3
    and    #$07                  ; 2
    cmp    #$07                  ; 2
    beq    LFB6B                 ; 2
    rts                          ; 6

LFB6B:
    lda    slidingBlock
    bpl    LFB70                 ; if not sliding
    rts

LFB70:
    ldy    #$00                  ; 2
    ldx    #$03                  ; 2
LFB74:
    lda    dinoColors,X
    bne    LFB79                 ; 2
    iny                          ; 2
LFB79:
    dex                          ; 2
    bpl    LFB74                 ; 2
    cpy    #$04                  ; 2
    beq    LFB81                 ; 2
    rts                          ; 6

LFB81:
    lda    #$0D                  ; 2
    sta    ram_D0                ; 3
    ldx    playerNum             ; 3
    inc    levelNum,X            ; 6
    lda    levelNum,X            ; 4
    and    #$0F                  ; no more then 16 levels
    sta    levelNum,X            ; 4
    jsr    LFBF7                 ; 6
    lda    #$00                  ; 2
    sta    AUDV0                 ; 3
    sta    frameCounter          ; 3
    jmp    GotoLF049             ; 3

LFB9B:
    lda    frameCounter          ; 3
    and    #$07                  ; 2
    bne    GotoLF049             ; 2
    dec    ram_D0                ; 5
    ldx    ram_D0                ; 3
    lda    LFBEA,X               ; 4
    sta    AUDF1                 ; 3
    lda    #$04                  ; 2
    sta    AUDC1                 ; 3
    lda    #$0F                  ; 2
    sta    AUDV1                 ; 3
    dex                          ; 2
    bpl    GotoLF049             ; 2
    lda    #$00                  ; 2
    sta    ram_D0                ; 3
    sta    ram_AC                ; 3
    sta    ram_82                ; 3
    sta    indexDinosaurs        ;
    sta    currentDinosaur       ; start at dinosaur 1
    sta    ram_B4                ; 3
    sta    slidingBlock
    sta    ram_C8                ; 3
    sta    AUDV1                 ; 3
    lda    #$0F                  ; 2
    sta    AUDV0                 ; 3
    lda    #$1F                  ; 2
    sta    ram_D8                ; 3
    lda    #$2F                  ; 2
    sta    ram_D8+1                ; 3
    lda    #$4F                  ; 2
    sta    ram_D8+2                ; 3
    lda    #$8F                  ; 2
    sta    ram_D8+3                ; 3
    rts                          ; 6

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; could just use PLA-PLA-JMP

GotoLF049:
    pla                          ; 4
    pla                          ; 4
    lda    #>LF049               ; 2
    pha                          ; 3
    lda    #<LF049               ; 2
    sec                          ; 2
    sbc    #$01                  ; 2
    pha                          ; 3
    rts                          ; 6

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LFBEA:
    .byte $00 ; |        | $FBEA  AUDF1
    .byte $00 ; |        | $FBEB
    .byte $17 ; |   X XXX| $FBEC
    .byte $17 ; |   X XXX| $FBED
    .byte $17 ; |   X XXX| $FBEE
    .byte $17 ; |   X XXX| $FBEF
    .byte $13 ; |   X  XX| $FBF0
    .byte $15 ; |   X X X| $FBF1
    .byte $15 ; |   X X X| $FBF2
    .byte $13 ; |   X  XX| $FBF3
    .byte $15 ; |   X X X| $FBF4
    .byte $15 ; |   X X X| $FBF5
    .byte $13 ; |   X  XX| $FBF6

LFBF7:
    ldy    playerNum
    lda.wy levelNum,Y
    asl                          ; times 2 for WORD size
    tax
    lda    LevelConfigTab,X
    sta    tempPtr
    lda    LevelConfigTab+1,X
    sta    tempPtr+1

    ldy    #0
.loopGetStones:
    lda    (tempPtr),Y           ; get stones for current level
    sta.wy stoneOrder,Y
    iny
    cpy    #16                   ; 8 rows, and 2 bytes required for each row (left and right sides)
    bne    .loopGetStones

    ldx    #0
.loopGetDinoPositions:
    lda    (tempPtr),Y          ; place dinosaurs for current level
    sta    dinoPositions,X
    inx
    iny
    cpy    #20
    bne    .loopGetDinoPositions

    lda    (tempPtr),Y
    sta    cavemanYpos           ; caveman position in terms of rows (1-8)
    iny
    lda    (tempPtr),Y
    sta    cavemanXpos           ; caveman position in terms of columns (1-10)

    CAVEMAN_PTRS  CaveManGfx_C, ColCaveManGfx_C

    lda    #>DinoGfx_A
    sta    dinosaurPtr+1
    lda    #<DinoGfx_A
    sta    dinoLoPtr
    sta    dinoLoPtr+1
    sta    dinoLoPtr+2
    sta    dinoLoPtr+3
    lda    #COL_PF_BLOCKS
    sta    ram_DC                ; 3

    lda    #COL_DINO1            ; Stored in ram, and when the dinosaur is dead the color is cleared to 0.
    sta    dinoColors
    lda    #COL_DINO2
    sta    dinoColors+1
    lda    #COL_DINO3
    sta    dinoColors+2
    lda    #COL_DINO4
    sta    dinoColors+3
    rts

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LFC5C:
    lda    ram_D1                ; 3
    bne    LFC7C                 ; 2
    lda    CXPPMM                ; 3
    bmi    LFC65                 ; 2
    rts                          ; 6

LFC65:
    lda    #$04                  ; 2
    sta    ram_D1                ; 3
    lda    #$00                  ; 2
    sta    frameCounter          ; 3
    lda    #$06                  ; 2
    sta    AUDC1                 ; 3
    lda    #$03                  ; 2
    sta    AUDF1                 ; 3
    lda    #$0D                  ; 2
    sta    AUDV1                 ; 3
    jmp    GotoLF049             ; 3

LFC7C:
    cmp    #$FF                  ; 2
    bne    LFC8D                 ; 2
    lda    frameCounter          ; 3
    bne    LFC8A                 ; 2
    lda    playerNum             ; 3
    eor    gameMode              ; 3
    sta    playerNum             ; 3
LFC8A:
    jmp    GotoLF049             ; 3

LFC8D:
    ldx    #$03                  ; 2
    lda    frameCounter          ; 3
    and    #$0F                  ; 2
    beq    LFC98                 ; 2
    jmp    GotoLF049             ; 3

LFC98:
    sta    dinoColors,X
    dex                          ; 2
    bpl    LFC98                 ; 2
    sta    CXCLR                 ; 3
    sta    AUDV0                 ; 3
    lda    ram_D1                ; 3
    asl                          ; 2
    tax                          ; 2
    lda    DeathGfxPtrs,X        ; 4
    sta    cavemanPtr
    lda    DeathGfxPtrs+1,X      ; 4
    sta    cavemanPtr+1
    lda    #<DeathGfxColTab
    sta    cavemanColPtr
    lda    #>DeathGfxColTab
    sta    cavemanColPtr+1
    lda    DeathSoundFreqTab,X   ; 4
    sta    AUDF1                 ; 3
    dec    ram_D1                ; 5
    beq    LFCC3                 ; 2
    jmp    GotoLF049             ; 3

LFCC3:
    lda    #$00                  ; 2
    sta    AUDV1                 ; 3
    ldx    playerNum             ; 3
    dec    numOfLivesP0,X
    bne    LFCD8                 ; 2
    cpx    gameMode              ; 3
    bne    LFCD8                 ; 2
    lda    #$FF                  ; 2
    sta    ram_D1                ; 3
    jmp    GotoLF049             ; 3

LFCD8:
    lda    gameMode              ; 3
    eor    playerNum             ; 3
    sta    playerNum             ; 3
    tax                          ; 2
    dec    levelNum,X            ; 6
    jmp    LFB81                 ; 3

DeathGfx_A:
    .byte $00 ; |        |
    .byte $00 ; |        |
    .byte $00 ; |        |
    .byte $00 ; |        |
    .byte $00 ; |        |
    .byte $00 ; |        |
    .byte $00 ; |        |
    .byte $00 ; |        |
DeathGfx_B:
    .byte $00 ; |        |
    .byte $52 ; | X X  X |
    .byte $00 ; |        |
    .byte $02 ; |      X |
    .byte $40 ; | X      |
    .byte $00 ; |        |
    .byte $4A ; | X  X X |
    .byte $00 ; |        |
DeathGfx_C:
    .byte $00 ; |        |
    .byte $00 ; |        |
    .byte $24 ; |  X  X  |
    .byte $00 ; |        |
    .byte $00 ; |        |
    .byte $24 ; |  X  X  |
    .byte $00 ; |        |
    .byte $00 ; |        |
DeathGfx_D:
    .byte $00 ; |        |
    .byte $00 ; |        |
    .byte $00 ; |        |
    .byte $18 ; |   XX   |
    .byte $18 ; |   XX   |
    .byte $00 ; |        |
    .byte $00 ; |        |
    .byte $00 ; |        |
DeathGfxColTab:
    .byte COL_48
    .byte COL_48
    .byte COL_48
    .byte COL_48
    .byte COL_48
    .byte COL_48
    .byte COL_48
    .byte COL_48
DeathSoundFreqTab:
    .byte $00 ; |        |
    .byte $00 ; |        |
    .byte $00 ; |        |
    .byte $00 ; |        |
    .byte $09 ; |    X  X|
    .byte $09 ; |    X  X|
    .byte $07 ; |     XXX|
    .byte $07 ; |     XXX|
    .byte $05 ; |     X X|
    .byte $05 ; |     X X|

DeathGfxPtrs:
    .word DeathGfx_A
    .word DeathGfx_A
    .word DeathGfx_B
    .word DeathGfx_C
    .word DeathGfx_D

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DinosaurMovement; SUBROUTINE
    lda    frameCounter
    ldx    playerNum
    and    difficultyP0,X
    cmp    #$02                  ; 2
    beq    LFD2B                 ; 2
    rts                          ; 6

LFD2B:
    lda    slidingBlock
    bpl    LFD30                 ; if not sliding
    rts

LFD30:
    jsr    LF7C9                 ; 6
    ldx    indexDinosaurs
    lda    ram_B4                ; 3
    and    ram_D8,X              ; 4
    sta    ram_AD                ; 3
    lda    ram_D8,X              ; 4
    eor    #$0F                  ; 2
    and    ram_B4                ; 3
    eor    #$0F                  ; 2
    sta    ram_D8,X              ; 4
    lda    #$F0                  ; 2
    sta    ram_AE                ; 3
    lda    ram_B2                ; 3
    cmp    cavemanYpos
    beq    LFD5F                 ; 2
    bcs    LFD59                 ; 2
    lda    #$02                  ; 2
    ora    ram_AE                ; 3
    sta    ram_AE                ; 3
    bne    LFD5F                 ; 2
LFD59:
    lda    #$01                  ; 2
    ora    ram_AE                ; 3
    sta    ram_AE                ; 3
LFD5F:
    lda    ram_B3                ; 3
    cmp    cavemanXpos
    beq    LFD75                 ; 2
    bcs    LFD6F                 ; 2
    lda    #$08                  ; 2
    ora    ram_AE                ; 3
    sta    ram_AE                ; 3
    bne    LFD75                 ; 2
LFD6F:
    lda    #$04                  ; 2
    ora    ram_AE                ; 3
    sta    ram_AE                ; 3
LFD75:
    lda    ram_AE                ; 3
    and    ram_AD                ; 3
    and    #$0F                  ; 2
    beq    LFD82                 ; 2
    sta    ram_AD                ; 3
    jmp    MoveDinosaur          ; 3

LFD82:
    lda    ram_AD                ; 3
    lsr                          ; 2
    lsr                          ; 2
    lsr                          ; 2
    lsr                          ; 2
    sta    ram_AE                ; 3
    and    ram_AD                ; 3
    beq    LFD93                 ; 2
    sta    ram_AD                ; 3
    jmp    MoveDinosaur          ; 3

LFD93:
    lda    ram_AE                ; 3
    and    ram_B4                ; 3
    bne    LFDB3                 ; 2
    lda    ram_AE                ; 3
    cmp    #$01                  ; 2
    bne    LFDA2                 ; 2
    asl                          ; 2
    bne    LFDB1                 ; 2
LFDA2:
    cmp    #$02                  ; 2
    bne    LFDA9                 ; 2
    lsr                          ; 2
    bne    LFDB1                 ; 2
LFDA9:
    cmp    #$04                  ; 2
    bne    LFDB0                 ; 2
    asl                          ; 2
    bne    LFDB1                 ; 2
LFDB0:
    lsr                          ; 2
LFDB1:
    sta    ram_AE                ; 3
LFDB3:
    lda    ram_AD                ; 3
    and    #$0F                  ; 2
    beq    LFDBE                 ; 2
    sta    ram_AD                ; 3
    jmp    MoveDinosaur          ; 3

LFDBE:
    lda    ram_AE                ; 3
    and    ram_B4                ; 3
    beq    LFDC9                 ; 2
    sta    ram_AD                ; 3
    jmp    MoveDinosaur          ; 3

LFDC9:
    rts                          ; 6

MoveDinosaur:
    lda    ram_AD                ; 3
    lsr
    bcc    .checkDinoDown
    jmp    MoveDinoUp

.checkDinoDown:
    lsr
    bcc    .checkDinoLeft
    jmp    MoveDinoDown

.checkDinoLeft:
    lsr
    bcc    .doDinoRight
    jmp    MoveDinoLeft

.doDinoRight:
    jmp    MoveDinoRight

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CheckSwitches; SUBROUTINE
    ldx    #HARD_SETTING
    lda    #EASY_SETTING
    sta    difficultyP0
    sta    difficultyP1          ; default to easy
    lda    SWCHB
    bpl    .checkP0difficulty
    stx    difficultyP1
.checkP0difficulty:
    and    #DIFFICULTY_SWITCH_P1
    beq    .checkSelectSwitch
    stx    difficultyP0
.checkSelectSwitch:
    lda    SWCHB
    and    #SELECT_SWITCH
    eor    ram_DE
    and    #SELECT_SWITCH
    beq    .checkReset
    eor    ram_DE                ; 3
    sta    ram_DE                ; 3
    and    #SELECT_SWITCH
    bne    .checkReset
    lda    gameMode
    eor    #GAME_MODE_FLAG
    sta    gameMode
    jmp    DoReset

.checkReset:
    lda    SWCHB
    and    #RESET_SWITCH
    eor    ram_DE
    and    #RESET_SWITCH
    beq    LFE28                 ; 2
    eor    ram_DE
    sta    ram_DE
    and    #RESET_SWITCH
    bne    LFE28                 ; 2
    jmp    DoReset

LFE28:
    rts

DoReset:
    lda    #0
    sta    AUDV0                 ; kill audio
    sta    AUDV1
    sta    CXCLR
    sta    ram_E6                ; 3
    ldx    #0
LFE35:
    sta    ram_C9,X              ; 4
    inx
    cpx    #9
    bne    LFE35                 ; 2
    lda    #$80                  ; 2
    sta    ram_DF                ; 3
    lda    #START_LIVES
    sta    numOfLivesP0
    ldy    gameMode
    bne    LFE4A                 ; 2
    lda    #0
LFE4A:
    sta    numOfLivesP1
    jsr    LFBF7                 ; 6
    lda    #$0D                  ; 2
    sta    ram_D0                ; 3
    jmp    GotoLF049             ; 3

  IF SHOW_FREE_BYTES
    ECHO [$FE70-*]d, "free bytes"
  ENDIF
SHOW_FREE_BYTES = 1

       ORG $FE70

LevelConfigTab:
    .word Level_01
    .word Level_02
    .word Level_03
    .word Level_04
    .word Level_05
    .word Level_06
    .word Level_07
    .word Level_08
    .word Level_09
    .word Level_10
    .word Level_11
    .word Level_12
    .word Level_13
    .word Level_14
    .word Level_15
    .word Level_16

Level_01:
    stones ___X_X____
    stones XX_X_XXXX_
    stones ___X______
    stones _XXX_XX_X_
    stones ______X_X_
    stones XX_X__X_X_
    stones _X_XX_X_XX
    stones ___X__X___

    dino1PosXY   1,8
    dino2PosXY   10,8
    dino3PosXY   1,1
    dino4PosXY   10,1
    cavemanPosXY 5,5

Level_03:
    stones ____X___X_
    stones _X_XX_XXX_
    stones _X__X_____
    stones _XX_XX_XX_
    stones _______X__
    stones _XXX___X__
    stones XX___XXX__
    stones __________

    dino1PosXY   3,8
    dino2PosXY   10,6
    dino3PosXY   1,4
    dino4PosXY   8,1
    cavemanPosXY 5,4

Level_02:
    stones __________
    stones _X_XXXXXX_
    stones _X____X___
    stones _X_X__X_X_
    stones _X_X__X_X_
    stones ___X____X_
    stones _XXXXXX_X_
    stones __________

    dino1PosXY   1,8
    dino2PosXY   10,8
    dino3PosXY   1,1
    dino4PosXY   10,1
    cavemanPosXY 5,5

Level_14:
    stones __________
    stones _XXX__XXX_
    stones _X______X_
    stones ____XX____
    stones ____XX____
    stones _X______X_
    stones _XXX__XXX_
    stones __________

    dino1PosXY   8,8
    dino2PosXY   1,6
    dino3PosXY   10,3
    dino4PosXY   3,1
    cavemanPosXY 7,5

Level_10:
    stones __________
    stones _XXX____X_
    stones __X_______
    stones __X_______
    stones _______X__
    stones _______X__
    stones _X____XXX_
    stones __________

    dino1PosXY   5,8
    dino2PosXY   10,5
    dino3PosXY   1,4
    dino4PosXY   6,1
    cavemanPosXY 7,4

Level_04:
    stones __________
    stones _X_XXXXXX_
    stones _X_X____X_
    stones _X_X__X_X_
    stones _X_XXXX_X_
    stones _X______X_
    stones _XXXXXXXX_
    stones __________

    dino1PosXY   5,6
    dino2PosXY   3,3
    dino3PosXY   1,1
    dino4PosXY   10,1
    cavemanPosXY 1,8

Level_08:
    stones __________
    stones _XXXXXXXX_
    stones _X______X_
    stones _X______X_
    stones _X______X_
    stones _X______X_
    stones _XXXXXXXX_
    stones __________

    dino1PosXY   3,6
    dino2PosXY   10,6
    dino3PosXY   1,3
    dino4PosXY   8,3
    cavemanPosXY 6,5

Level_06:
    stones __________
    stones _X_X_X_X__
    stones _X_X_X_X__
    stones __X_X_X_X_
    stones __X_X_X_X_
    stones _X_X_X_X__
    stones _X_X_X_X__
    stones __________

    dino1PosXY   1,8
    dino2PosXY   10,8
    dino3PosXY   1,1
    dino4PosXY   10,1
    cavemanPosXY 5,1

Level_12:
    stones ___X___X__
    stones _X___X___X
    stones ___X___X__
    stones _X___X___X
    stones ___X___X__
    stones _X___X___X
    stones ___X___X__
    stones _X___X___X

    dino1PosXY   1,8
    dino2PosXY   7,8
    dino3PosXY   5,5
    dino4PosXY   9,4
    cavemanPosXY 1,2

Level_15:
    stones __________
    stones _XXXXXXXX_
    stones __________
    stones _X_X__X_X_
    stones _X_X__X_X_
    stones __________
    stones _XXXXXXXX_
    stones __________

    dino1PosXY   1,6
    dino2PosXY   10,6
    dino3PosXY   1,3
    dino4PosXY   10,3
    cavemanPosXY 6,5

Level_16:
    stones X_________
    stones __X__X__X_
    stones _X__X__X__
    stones __________
    stones __X__X__X_
    stones _X__X__X__
    stones ___X__X___
    stones X________X

    dino1PosXY   7,8
    dino2PosXY   1,5
    dino3PosXY   10,5
    dino4PosXY   6,1
    cavemanPosXY 4,5

Level_11:
    stones __XXXX____
    stones _XXXXX_XXX
    stones _XX____XXX
    stones ____XX____
    stones X_XXXX_XX_
    stones X_XX___XX_
    stones X____X_XX_
    stones XXXXXX____

    dino1PosXY   1,5
    dino2PosXY   7,5
    dino3PosXY   2,2
    dino4PosXY   10,1
    cavemanPosXY 10,8

Level_09:
    stones ________X_
    stones _XXXXXXXX_
    stones _X___X____
    stones _X_X_X_X__
    stones _X_X_X_X__
    stones ___X___X__
    stones _XXXXXXX__
    stones _X_____X__

    dino1PosXY   2,8
    dino2PosXY   1,3
    dino3PosXY   5,3
    dino4PosXY   9,2
    cavemanPosXY 10,6

Level_13:
    stones __________
    stones _XX_XX_XX_
    stones _XX_XX_XX_
    stones _XX_XX____
    stones ____XX_XX_
    stones _XX_XX_XX_
    stones _XX_XX_XX_
    stones __________

    dino1PosXY   1,8
    dino2PosXY   10,5
    dino3PosXY   4,4
    dino4PosXY   9,1
    cavemanPosXY 1,4

Level_07:
    stones _____X_X__
    stones _XXX_X_X__
    stones __________
    stones _XX__XXX__
    stones _____X___X
    stones _XXXXX____
    stones _____X_X__
    stones __X__X_X__

    dino1PosXY   1,8
    dino2PosXY   10,8
    dino3PosXY   1,1
    dino4PosXY   10,1
    cavemanPosXY 5,4

Level_05:
    stones __________
    stones _X_XXXX_XX
    stones _X____X___
    stones _X____X___
    stones _X_X_XX_X_
    stones ___X____X_
    stones XX_XXX__X_
    stones ________X_

    dino1PosXY   1,8
    dino2PosXY   9,6
    dino3PosXY   3,3
    dino4PosXY   7,1
    cavemanPosXY 5,4


    .byte $C8 ; |XX  X   | $FFF0
    .byte $0A ; |    X X | $FFF1
    .byte $F0 ; |XXXX    | $FFF2
    .byte $02 ; |      X | $FFF3
    .byte $68 ; | XX X   | $FFF4
    .byte $08 ; |    X   | $FFF5
    .byte $90 ; |X  X    | $FFF6
    .byte $F0 ; |XXXX    | $FFF7
    .byte $28 ; |  X X   | $FFF8
    .byte $F0 ; |XXXX    | $FFF9
    .byte $20 ; |  X     | $FFFA
    .byte $B9 ; |X XXX  X| $FFFB

       ORG $FFFC
    .word START

    .byte $D0 ; |XX X    | $FFFE
    .byte $D6 ; |XX X XX | $FFFF
